Attribute VB_Name = "GLPicking3D"
'3D picking routine
Option Explicit

Public Sub ExamineClick3D(x As Single, y As Single, _
Triangles() As TRIANGLE, NumberOfTriangles, Active, result, Succes)
  Dim CheckActive As Integer
  Dim ActiveLayer As Integer
  Dim HitIdentif(1 To 2) As Integer
  Dim i As Integer
  Dim hits As Long
  Dim selectbuf(0 To 30000) As GLuint ' array for the reultes of picking
  Dim BUFSIZE As Integer
  BUFSIZE = 30000

  For i = 1 To 3
    If Active(i) Then
      CheckActive = CheckActive + 1 ' count N of active layers
      ActiveLayer = i ' identify the active layer
    End If
  Next i

  If CheckActive <> 1 Then
     MsgBox "Exactly 1 layer must be used for 3D ELD map picking  !!"
     Succes = False
     GoTo skip
  End If

  Selection x, y, hits, selectbuf, BUFSIZE, _
  Triangles, NumberOfTriangles, ActiveLayer, HitIdentif
  
  If hits <> 2 Then ' wrong number of triangles in the hit
    Succes = False
    GoTo skip
  End If
  
  
    result(1) = _
    ( _
    ((Triangles(ActiveLayer, HitIdentif(1)).p(0).x + _
    Triangles(ActiveLayer, HitIdentif(1)).p(1).x + _
    Triangles(ActiveLayer, HitIdentif(1)).p(2).x) / 3) + _
 _
    ((Triangles(ActiveLayer, HitIdentif(2)).p(0).x + _
    Triangles(ActiveLayer, HitIdentif(2)).p(1).x + _
    Triangles(ActiveLayer, HitIdentif(2)).p(2).x) / 3) _
    ) / 2
    
     result(2) = _
    ( _
    ((Triangles(ActiveLayer, HitIdentif(1)).p(0).y + _
    Triangles(ActiveLayer, HitIdentif(1)).p(1).y + _
    Triangles(ActiveLayer, HitIdentif(1)).p(2).y) / 3) + _
 _
    ((Triangles(ActiveLayer, HitIdentif(2)).p(0).y + _
    Triangles(ActiveLayer, HitIdentif(2)).p(1).y + _
    Triangles(ActiveLayer, HitIdentif(2)).p(2).y) / 3) _
    ) / 2
    
     result(3) = _
    ( _
    ((Triangles(ActiveLayer, HitIdentif(1)).p(0).z + _
    Triangles(ActiveLayer, HitIdentif(1)).p(1).z + _
    Triangles(ActiveLayer, HitIdentif(1)).p(2).z) / 3) + _
 _
    ((Triangles(ActiveLayer, HitIdentif(2)).p(0).z + _
    Triangles(ActiveLayer, HitIdentif(2)).p(1).z + _
    Triangles(ActiveLayer, HitIdentif(2)).p(2).z) / 3) _
    ) / 2

  
  Succes = True

skip:
End Sub

Private Sub Selection(x As Single, y As Single, _
hits As Long, selectbuf() As GLuint, BUFSIZE As Integer, _
Triangles() As TRIANGLE, NumberOfTriangles, ActiveLayer As Integer, HitIdentif)

  Dim viewport(0 To 3) As Long ' array for viewport
  glGetIntegerv GL_VIEWPORT, viewport(0)
  glSelectBuffer BUFSIZE, selectbuf(0)
  glDisable GL_STENCIL_TEST
  glDisable GL_DEPTH_TEST
  glRenderMode GL_SELECT
  glInitNames
  glPushName 0 'intializing the name stack
  'setting the same geomety as for normal view
  glMatrixMode GL_PROJECTION
    glPushMatrix 'saving the original matrix
    glLoadIdentity
    '1*1 region near cursor
    gluPickMatrix x, viewport(3) - y, 1, 1, viewport(0)
    frmMain.Kamera "CentralEyePicking"
    glMatrixMode GL_MODELVIEW
        glPushMatrix
        frmMain.recalcModelView
    
        DrawNumberedTriangles Triangles, NumberOfTriangles, ActiveLayer
        'restoring the geometry
        glPopMatrix
    glMatrixMode GL_PROJECTION
    glPopMatrix 'restoring the original matrix
  glMatrixMode GL_MODELVIEW
  glFlush
  
   ' for debugging
  'SwapBuffers frmMain.hDC
    
  hits = glRenderMode(GL_RENDER)   'hits = objects in hit
   
  If hits = 2 Then
    HitIdentif(1) = selectbuf((1 - 1) * 4 + 3) ' identify the hit numbers
    HitIdentif(2) = selectbuf((2 - 1) * 4 + 3)
  End If
  
End Sub
Public Sub processHits(hits As Long, selectbuf, x As Single, y As Single, result As Long)

'Example declaration of required variables

'Dim result As Long
'Dim hits As Long
'Dim selectbuf(0 To 512) As GLuint ' array for the reultes of picking
'Dim BUFSIZE As Integer
'BUFSIZE = 512

Dim i As Integer
Dim dist As Single, helpvar As GLuint
       
        If hits = 0 Then Exit Sub
        If hits > 0 Then
            Beep
            result = 0
            dist = 1E+30 ' very big number :)
            For i = 1 To hits
                helpvar = selectbuf((i - 1) * 4 + 1)
                If (GLuint_to_Single(helpvar) < dist) Then 'The distance to picked objekt
                    dist = GLuint_to_Single(helpvar)
                    result = selectbuf((i - 1) * 4 + 3) ' result = number of picked objekt
                End If
            Next i
        End If
End Sub

Private Function GLuint_to_Single(GLuint As GLuint) As Single
' Transformation of GLuint varibale (UnsignedLongInteger in C , no equivalent in VB) to Single
Dim result As Single

    result = GLuint
    If result < 0 Then result = 2147483648# + (2147483648# + result)
    GLuint_to_Single = result

End Function

Private Sub DrawNumberedTriangles(Triangles() As TRIANGLE, _
NumberOfTriangles, ActiveLayer)

Dim i As Integer, j As Integer

   For i = 1 To NumberOfTriangles(ActiveLayer)
          glLoadName (i)
          
          ' Nice for debuging
          ' glColor3f Rnd(1), Rnd(1), Rnd(1)
          glBegin GL_TRIANGLES
                For j = 0 To 2
                 
                    glVertex3f Triangles(ActiveLayer, i).p(j).x, _
                               Triangles(ActiveLayer, i).p(j).y, _
                               Triangles(ActiveLayer, i).p(j).z
                Next j
          glEnd
  Next i

End Sub

