Attribute VB_Name = "DataManipulace"
' ver 4
Sub ZvolBarvu(AtomNazev$)
' THIS FUNCTION IS NOT USED BY MCE !!
Select Case AtomNazev$
    Case "C "
        glColor3f 0.1, 0.8, 0.1 'green for carbon
    Case "H "
        glColor3f 0#, 0#, 1   'blue for hydrogen
        Case "O "
        glColor3f 0.9, 0.1, 0.1 'red for oxygen
    Case "N "
        glColor3f 0.05, 0.05, 0.9 'blue for nitogen
        Case Else
        glColor3f 0.5, 0.5, 0.6 ' gray
End Select
    
End Sub
Function ZvolPolomerVDW2(AtomNazev$) As Single
' THIS FUNCTION IS NOT USED BY MCE !!
Dim result As Single

Select Case AtomNazev$

    Case "C "
        result = 1.7
        
    Case "O "
        result = 1.52
    Case "N "
        result = 1.58
    Case "H "
        result = 1.17
    Case Else
        result = 1.5
        
End Select

ZvolPolomerVDW2 = result
    
End Function

Function Maximum(Pole, DelkaPole)
    Dim i As Integer
    Dim Max As Variant
    Max = Pole(1)
    For i = 2 To DelkaPole
        If Pole(i) > Max Then Max = Pole(i)
    Next i
    Maximum = Max
End Function

Function Minimum(Pole, DelkaPole)
    Dim i As Integer
    Dim Min As Variant
    Min = Pole(1)
    For i = 2 To DelkaPole
        If Pole(i) < Min Then Min = Pole(i)
    Next i
    Minimum = Min
End Function

Function Vzdalenost(x1, y1, z1, x2, y2, z2)
Dim delta1, delta2, delta3
delta1 = x1 - x2
delta2 = y1 - y2
delta3 = z1 - z2
Vzdalenost = Sqr(delta1 * delta1 + delta2 * delta2 + delta3 * delta3)
End Function

Public Sub GenerujVazby(AtomDescription, AtomNames, PocetAtomu As Long, Vazba, PocetVazeb As Long)

 
Dim AtomProperties(0 To 400, 1 To 7) As Variant
' field for atomic number decoding
' strukture of the filed (from  MOLDRAW software)
' atom Number, covrad,grar,VdWr,tolerance, name, weight
Dim i As Integer
Dim j As Integer
Dim DelakVazby As Single

Dim LimitMax As Single
Dim LimitMin As Single
PocetVazeb = 0

ReadAtomProperties AtomProperties
DecodeAtomNumbers AtomNames, AtomDescription, AtomProperties, PocetAtomu

For i = 1 To PocetAtomu
    For j = i + 1 To PocetAtomu
        'snad upravuje zdvojeni vazeb ??
        DelkaVazby = Vzdalenost( _
        AtomDescription(i, 1), _
        AtomDescription(i, 2), _
        AtomDescription(i, 3), _
        AtomDescription(j, 1), _
        AtomDescription(j, 2), _
        AtomDescription(j, 3))
        ChoseLimits AtomDescription(i, 13), AtomDescription(j, 13), AtomProperties, LimitMin, LimitMax
        If (DelkaVazby < LimitMax) And (DelkaVazby > LimitMin) Then
            PocetVazeb = PocetVazeb + 1
            Vazba(PocetVazeb, 1) = i
            Vazba(PocetVazeb, 2) = j
        End If
    Next j
Next i
End Sub

Private Sub ChoseLimits(A, b, Properties, LimitMin, LimitMax)
' set the limits for bond existence
' as the sume of COVR +- sume of Tolerance
Dim COVRA As Single, COVRB As Single
Dim ToleranceA As Single, ToleranceB As Single
  COVRA = Properties(A, 3)
  COVRB = Properties(b, 3)
  ToleranceA = Properties(A, 5)
  ToleranceB = Properties(b, 5)
  LimitMin = (COVRA + COVRB) - (ToleranceA + ToleranceB)
  LimitMax = (COVRA + COVRB) + (ToleranceA + ToleranceB)
End Sub

Private Sub ReadAtomProperties(Field)
' read properties of atomes
' number of recognized atom prop. recors stored in
' Field (0,1)
Dim A$
Dim NRecords As Integer
Dim N As Single
Open App.Path & "\" & "atompar2.txt" For Input As #1

Line Input #1, A$ ' reads the description header
NRecords = 0

Do
  Line Input #1, A$
  N = Val(Mid$(A$, 1, 3))
    If N < 1 Then Exit Do
  NRecords = NRecords + 1
  Field(NRecords, 1) = N ' atom number
  N = Val(Mid$(A$, 7, 3))
  Field(NRecords, 2) = N / 100 ' COVR
  N = Val(Mid$(A$, 14, 3))
  Field(NRecords, 3) = N / 100 ' GRAR
  N = Val(Mid$(A$, 21, 3))
  Field(NRecords, 4) = N / 100 ' VDWR
  N = Val(Mid$(A$, 27, 3))
  Field(NRecords, 5) = N  ' Tolerance
  Field(NRecords, 6) = Mid$(A$, 34, 4) ' name
  N = Val(Mid$(A$, 38, 10))
  Field(NRecords, 7) = N ' AtomWeight
Loop

Field(0, 1) = NRecords ' storing the number of knowen atom types

Close #1

End Sub

Private Sub DecodeAtomNumbers(AtomNames, AtomDescription, AtomProperties, PocetAtomu)
' this procedure add information about atom number
' decoded from its name to the AtomDescription
' 13 field part

Dim i As Integer
Dim j As Integer
For i = 1 To PocetAtomu
    j = 0
    Do
      j = j + 1
      ' identify the atom name, both strings must be 4 chracter lenght
      If AtomNames(i) = AtomProperties(j, 6) Then
         AtomDescription(i, 13) = AtomProperties(j, 1)
         Exit Do
      End If
      If j > AtomProperties(0, 1) Then
        MsgBox "I do not know this atom name: " + AtomNames(i)
        Stop
      End If
    Loop
Next i
End Sub

Public Sub InitializeLayerPresets()
Dim A$
Dim i As Integer
Open App.Path & "\" & "layer_limit_presets.txt" For Input As #1

For i = 1 To 3
    Line Input #1, A$
    LayerPresets(i, 4) = A$
    
    Line Input #1, A$
    LayerPresets(i, 1) = Val(A$)
    
    Line Input #1, A$
    LayerPresets(i, 2) = Val(A$)
    
    Line Input #1, A$
    LayerPresets(i, 3) = Val(A$)
Next i

Close #1

End Sub
