Attribute VB_Name = "PovrayOutput"
Public Sub SavePovrayFile(filename$)
Open filename$ For Output As #1

Print #1, "// Original ELD map filename:"
Print #1, "// " + InputFile$
ExportPovrayHead

Print #1, "union {"
 Print #1, "union {"
 
'    If NPeaks > 0 Then DisplayPeaks
   If AtomVisible Then DrawAtoms
    Select Case GridType
        Case 1
            SpiderGrid
        Case 2
            TriangleGrid
        Case Else
            Stop ' not defined grid
    End Select
        
    If ContourVisible Then ContourMap
    
     If CellVisible Then DrawCell
    
    SaveMatrix
  
 Print #1, "}"
 
Print #1, "scale <1,1,-1>"
Print #1, "}"

Close #1

End Sub
Private Sub SpiderGrid()
' spider like 3D web

  Dim Level As Integer
  Dim i As Long
  Dim j As Long
  Dim xs As XYZ ' center of triangle
     
  For Level = 1 To 3
    If Active(Level) Then
     Print #1, "union {"
        For i = 1 To NumberOfTriangles(Level)
          
          ' calculating center of the triangle
             xs = Average3Vector(Triangles(Level, i).p(0), Triangles(Level, i).p(1), Triangles(Level, i).p(2))
        'cylinder{ <Base_Point>, <Cap_Point>, Radius}
        
   ' testing the cylindres for zero lenght
   ' bug in MC topology !!!
                        
       cylinder Triangles(Level, i).p(0), xs, "cylRadius"

       cylinder xs, Triangles(Level, i).p(1), "cylRadius"

       cylinder xs, Triangles(Level, i).p(2), "cylRadius"
          
    Next i
       
        ' setting the layer color
        SetColor Level
        Print #1, "}"
                
    End If
        
Next Level

End Sub

Sub TriangleGrid()
  ' triangle like grid
  Dim Level As Integer
  Dim i As Long
  Dim j As Long

  For Level = 1 To 3
    If Active(Level) Then
    Print #1, "union {"
                     
         For i = 1 To NumberOfTriangles(Level)
          cylinder _
            Triangles(Level, i).p(0), _
            Triangles(Level, i).p(1), "cylRadius"
           
          cylinder _
            Triangles(Level, i).p(1), _
            Triangles(Level, i).p(2), "cylRadius"
            
          cylinder _
            Triangles(Level, i).p(2), _
            Triangles(Level, i).p(0), "cylRadius"
        Next i
        
        ' setting the layer color
        SetColor Level
        Print #1, "}"
        
    End If
    
  Next Level

End Sub

Sub ContourMap()
  Dim Level As Integer
  Dim i As Long
  Dim j As Long
  Dim x0 As GLfloat
  Dim y0 As GLfloat
  Dim z As GLfloat
  Dim x1 As GLfloat
  Dim y1 As GLfloat
 
  
  ' contour map
  For Level = 1 To 3
      Print #1, "union {"
    For i = 1 To NumberOfContourLines(Level)
   
       cylinder_old _
        Contour(Level, i, 1, 1), _
        Contour(Level, i, 1, 2), _
        Contour(Level, i, 1, 3), _
        Contour(Level, i, 2, 1), _
        Contour(Level, i, 2, 2), _
        Contour(Level, i, 2, 3), "cylRadius"
    Next i
        
    SetColor Level
    Print #1, "}"
        
  Next Level

' rectangle around the contour map
' calculating of the position in the space
  x0 = VoxelDescription(4)
  y0 = VoxelDescription(5)
  z = (ContourZHight - 1) * VoxelDescription(9) + VoxelDescription(6)
  x1 = x0 + (VoxelDescription(1) - 1) * VoxelDescription(7)
  y1 = y0 + (VoxelDescription(2) - 1) * VoxelDescription(8)

Print #1, "union {"
 cylinder_old x0, y0, z, x1, y0, z, "cylRadius"
 cylinder_old x1, y0, z, x1, y1, z, "cylRadius"
 cylinder_old x1, y1, z, x0, y1, z, "cylRadius"
 cylinder_old x0, y1, z, x0, y0, z, "cylRadius"

Print #1, "pigment { color Gray40 }"
Print #1, "}"
    
End Sub
Sub DrawCell()

' draw the  lattice cell
  Dim i As Integer
  Dim i2 As Integer
  
  Print #1, "union {"
  
    For i = 1 To 4
            If (i < 4) Then
                i2 = i + 1
            Else
                i2 = 1
            End If
        cylinder _
            CellEndPoints(i), _
            CellEndPoints(i2), "cylRadius"
     Next i
     
    For i = 5 To 8
            If (i < 8) Then
                i2 = i + 1
            Else
                i2 = 5
            End If
            
        cylinder _
            CellEndPoints(i), _
            CellEndPoints(i2), "cylRadius"
    Next i
    
    cylinder _
            CellEndPoints(1), _
            CellEndPoints(5), "cylRadius"
    cylinder _
            CellEndPoints(2), _
            CellEndPoints(6), "cylRadius"
            
    cylinder _
            CellEndPoints(3), _
            CellEndPoints(7), "cylRadius"
    
    cylinder _
            CellEndPoints(4), _
            CellEndPoints(8), "cylRadius"

Print #1, "pigment { color Gray80 }"
Print #1, "}"
            
End Sub


Private Sub cylinder(p1 As XYZ, p2 As XYZ, radius$)

If CheckCylinder(p1.X, p1.Y, p1.z, p2.X, p2.Y, p2.z) Then
    Print #1, "cylinder{<";
        Print #1, p1.X; ",";
        Print #1, p1.Y; ",";
        Print #1, p1.z; ">";
        Print #1, ",<";
        Print #1, p2.X; ",";
        Print #1, p2.Y; ",";
        Print #1, p2.z; ">";
        Print #1, ",";
        Print #1, radius$;
    Print #1, "}"
End If

End Sub

Private Sub SetColor(Level As Integer)

Select Case Level
        Case 1
         Print #1, "pigment { color Level1Color }"
        Case 2
         Print #1, "pigment { color Level2Color }"
        Case 3
         Print #1, "pigment { color Level3Color }"
End Select

End Sub

Private Sub DrawAtoms()
  Dim i As Integer
  Dim at1 As Integer
  Dim at2 As Integer
     
  For i = 1 To Natoms
    'AtomColor (AtomNames(i))
    'glTranslatef Atoms(i, 1), Atoms(i, 2), Atoms(i, 3)
    'Koule quadObj, AtomRadius(AtomNames(i)), 8
    
    Print #1, "sphere {<";
        Print #1, Atoms(i, 1); ",";
        Print #1, Atoms(i, 2); ",";
        Print #1, Atoms(i, 3); ">";
        Print #1, ",";
        'Print #1, AtomRadius(AtomNames(i));
        Print #1, "AtomRadiusFor" + AtomNames(i);
            Print #1, " pigment { color ";
            Print #1, "ColorFor" + AtomNames(i);
            Print #1, "}";
    Print #1, "}"
  Next i
  
Print #1, "union {"
   For i = 1 To NBonds
     at1 = Vazby(i, 1)
     at2 = Vazby(i, 2)
     cylinder_old _
     Atoms(at1, 1), Atoms(at1, 2), Atoms(at1, 3), _
     Atoms(at2, 1), Atoms(at2, 2), Atoms(at2, 3), "bondcylRadius"
   Next i
   
Print #1, "pigment { color Gray }"
Print #1, "}"

End Sub

Private Sub SaveMatrix()
' saving the OpenGL orientation,
' scaling and translation matrix
' into POVRAY format

Dim matrix(1 To 16) As GLfloat
Dim i As Integer

glMatrixMode mmModelView

frmMain.recalcModelView

glGetFloatv glgModelViewMatrix, matrix(1)

Print #1, "matrix <"

Print #1, matrix(1); " , "; matrix(2); " , "; matrix(3); " , "
Print #1, matrix(5); " , "; matrix(6); " , "; matrix(7); " , "
Print #1, matrix(9); " , "; matrix(10); " , "; matrix(11); " , "
Print #1, matrix(13); " , "; matrix(14); " , "; matrix(15)

Print #1, ">"

End Sub

Private Sub ExportPovrayHead()
Dim a$

Open App.Path & "\" & "ELDmap_POVray_head.def" For Input As #2

Do
    Line Input #2, a$
    If a$ = "//END OF FILE" Then Exit Do
    Print #1, a$
Loop

Close #2
End Sub

Private Function CheckCylinder(x1, y1, z1, x2, y2, z2) As Boolean

Dim CylinderLenght As Single

CylinderLenght = Sqr((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1) + (z2 - z1) * (z2 - z1))

If CylinderLenght < 0.0001 Then
    CheckCylinder = False
   ' MsgBox ("Lenghtof cylinder < 0.0001, cylinder rejected")
Else
    CheckCylinder = True
End If
    
End Function

Private Sub cylinder_old(x1, y1, z1, x2, y2, z2, radius$)

If CheckCylinder(x1, y1, z1, x2, y2, z2) Then
    Print #1, "cylinder{<";
        Print #1, x1; ",";
        Print #1, y1; ",";
        Print #1, z1; ">";
        Print #1, ",<";
        Print #1, x2; ",";
        Print #1, y2; ",";
        Print #1, z2; ">";
        Print #1, ",";
        Print #1, radius$;
    Print #1, "}"
End If

End Sub
