Attribute VB_Name = "ReadAndSaveDensity"
Public Sub ReadDensityBIN1(filename As String, VoxelDescription, Voxel, AtomName, AtomDescription, Natoms As Long)
' reading the original binary CRYSTALS input
  Dim A$ ' help variable for reading strings
  Dim i As Integer ' help index for cycles
  Dim RecordLenght As Long
  Dim Lines As Long
  Dim Columns As Long
  Dim Sections As Long
  Dim Min As Single
  Dim Max As Single
  Dim x As Integer
  Dim y As Integer
  Dim z As Integer
  Dim N As Single ' help variable for reading dumy Single
  Dim Dens As Single ' electron density

  Open filename For Binary Access Read As #1

  'initial string
  A$ = Input(38, 1) '35 char + 3?

  ' 9 elements of the transformation rotation matrix
  For i = 1 To 3
    For j = 1 To 3
      Get #1, , N
      PlaneMatrix(i, j) = N
      
    Next j
  Next i

' 3 elements of aditinal translation matrix

  For i = 1 To 3
    Get #1, , N
    PlaneTranslation(i) = N
  Next i

  'something
  A$ = Input(2, 1)

  ' cell
  A$ = Input(4, 1)
  
  ' 6 lattice parameters
  ' 26 pro 6 hodnot asi 4 byty na hodnotu + 2 cosy
  For i = 1 To 6
    Get #1, , N
    Cell(i) = N
  Next i

 '"L14 " + 2 something
  A$ = Input(6, 1)
  
  'content of list 14 3x4 values
  ' 48 pro 12 hodnot
  For i = 1 To 3 ' for x y z
    Get #1, , N 'Start
    VoxelDescription(3 + i) = N
    Get #1, , N 'Step
    VoxelDescription(6 + i) = N
    Get #1, , N 'End
    Get #1, , N 'Division
  Next i

  'SIZE + 2 of something
  A$ = Input(6, 1)

  'lines coloms section ?
 ' 12 pro 3 hodnot Long Integer !!
  Get #1, , Lines
  Get #1, , Columns
  Get #1, , Sections
  VoxelDescription(1) = Lines 'number of x's
  VoxelDescription(2) = Columns 'number of y's
  VoxelDescription(3) = Sections ' number of z's

  ReDim Voxel(VoxelDescription(1), VoxelDescription(2), VoxelDescription(3))

  Min = 1E+30
  Max = -1E+30

  For z = 1 To Sections
    Select Case z
      Case 1
        A$ = Input(10, 1)
      Case Else
        A$ = Input(14, 1)
    End Select

     For x = 1 To Lines
        For y = 1 To Columns
        
        Get #1, , Dens
        If Dens > 10000 Then
          MsgBox "Your input data looks strange, ELD > 10000"
          Stop
        End If
        If Dens < -10000 Then
          MsgBox "Your input data looks strange, ELD < -10000"
          Stop
        End If
        If Dens > Max Then Max = Dens
        If Dens < Min Then Min = Dens
        Voxel(x, y, z) = Dens
        
     Next y
   Next x
        
  Next z

  VoxelDescription(10) = Min
  VoxelDescription(11) = Max
     
  ' atom parametes shuld start in this place
     
  A$ = Input(6, 1)
  Get #1, , Natoms
  Get #1, , RecordLenght
  If RecordLenght <> 14 Then Stop

  ReDim AtomName(1 To Natoms) As String ' name of atoms field
  ReDim AtomDescription(1 To Natoms, 1 To 13) As Single
  ' filed of atoms x,y,z,serial,occ,uiso,u1,u2,u3,u4,u5,u6,AtomNumber
     
  For i = 1 To Natoms
    A$ = Input(2, 1) ' dumy something
    A$ = Input(4, 1) 'name of the atome
    AtomName(i) = A$
    Get #1, , N
    AtomDescription(i, 4) = N
    Get #1, , N
    AtomDescription(i, 5) = N
    Get #1, , N
    AtomDescription(i, 6) = N
    For j = 1 To 3
      Get #1, , N
      AtomDescription(i, j) = N
    Next j
    For j = 6 To 12
      Get #1, , N
      AtomDescription(i, j) = N
    Next j
  Next i
     
Transform AtomDescription, Natoms
 
Close #1

End Sub
Public Sub ReadDensityASCI1(filename As String, VoxelDescription, Voxel, AtomName, AtomDescription, Natoms As Long)
' ASCI CRYSTALS and WinGX reading routine
  Dim A$ ' help variable for reading strings
  Dim i As Integer ' help index for cycles
  Dim RecordLenght As Long
  Dim Lines As Long
  Dim Columns As Long
  Dim Sections As Long
  Dim Min As Single
  Dim Max As Single
  Dim x As Integer
  Dim y As Integer
  Dim z As Integer
  Dim N As Single ' help variable for reading dumy Single
  Dim Dens As Single ' electron density

  Open filename For Input As #1

  'initlaization string
  Line Input #1, A$ 'INFO DOWN, ....?
  Line Input #1, A$ 'TRAN ?
  ' 9 elements of rotation matrix
  For i = 1 To 3
    For j = 1 To 3
      Input #1, N
      PlaneMatrix(i, j) = N
    Next j
  Next i
  
' 3 elements of translation matrix

  For i = 1 To 3
    Input #1, N
    PlaneTranslation(i) = N
  Next i

  ' cell
  Line Input #1, A$ 'CELL
  
  ' 6 lattice parameters
  For i = 1 To 6
    Input #1, N
    Cell(i) = N
  Next i

 '"L14 "
  Line Input #1, A$ 'L14
  
  'content of list 14 3x4 values
  ' 48 pro 12 hodnot
  For i = 1 To 3 ' for x y z
    Input #1, N 'Start
    VoxelDescription(3 + i) = N
    Input #1, N 'Step
    VoxelDescription(6 + i) = N
    Input #1, N 'End
    Input #1, N 'Division
  Next i

   Line Input #1, A$ 'SIZE

  'lines coloms section
 Input #1, Lines
 Input #1, Columns
 Input #1, Sections
  VoxelDescription(1) = Lines 'number of x's
  VoxelDescription(2) = Columns 'number of y's
  VoxelDescription(3) = Sections ' number of z's

  ReDim Voxel(VoxelDescription(1), VoxelDescription(2), VoxelDescription(3))

  Min = 1E+30
  Max = -1E+30

  For z = 1 To Sections
     Line Input #1, A$ 'BLOCK
     Input #1, N 'number of values in one block

    For x = 1 To Lines
        For y = 1 To Columns
        
        Input #1, Dens
        If Dens > 10000 Then
          MsgBox "Your input data looks strange, ELD > 10000"
          Stop
        End If
        If Dens < -10000 Then
          MsgBox "Your input data looks strange, ELD < -10000"
          Stop
        End If
        If Dens > Max Then Max = Dens
        If Dens < Min Then Min = Dens
        Voxel(x, y, z) = Dens
    
        Next y
    Next x
    
  Next z

  VoxelDescription(10) = Min
  VoxelDescription(11) = Max

  
  ' atom parameters reading starts here
  Line Input #1, A$ 'LIST5
  Input #1, Natoms
  Input #1, RecordLenght
  
  '
  'If RecordLenght <> 14 Then
   ' MsgBox "Your atom list structure is strange <> 14 records"
   ' Stop
  'End If
  
  If Natoms > 0 Then

    ReDim AtomName(1 To Natoms) As String ' atomu names
    ReDim AtomDescription(1 To Natoms, 1 To 14) As Single
    ' 1-3 field of atoms x,y,z
    ' 4 -6 serial,occ,uiso
    ' 7 - 12 u1,u2,u3,u4,u5,u6
  ' 13-14 AtomNumber,Fragment number (for new CRYSTALS version)
     
  For i = 1 To Natoms

    Line Input #1, A$ 'atom name
    ' checking and correcting the atom name string lenght
    ' makes input more fexible
    Select Case Len(A$)
         
         Case 1
            A$ = A$ + "   "
         Case 2
             A$ = A$ + "  "
         Case 3
             A$ = A$ + " "
         Case 4
             ' it is O.K. do nothing
         Case Else
            MsgBox "Your atom name looks strange, name lengh  <> [1,2,3,4]"
         Stop
          
    End Select
                 
    AtomName(i) = A$
     Input #1, N
    AtomDescription(i, 4) = N
     Input #1, N
    AtomDescription(i, 5) = N
     Input #1, N
    AtomDescription(i, 6) = N
    For j = 1 To 3
      Input #1, N
      AtomDescription(i, j) = N
    Next j
    ' U
    For j = 6 To 12
       Input #1, N
      AtomDescription(i, j) = N
    Next j
        
    ' ignoring records in future CRYSTALS versions
    If RecordLenght > 14 Then
        For j = 15 To RecordLenght
            Line Input #1, A$ 'read dummy parameters
        Next j
    End If
    
  Next i
     
Transform AtomDescription, Natoms

End If 'Natoms > 0
 
Close #1

End Sub
Public Sub ReadDensityGRD(filename As String, VoxelDescription, Voxel, AtomName, AtomDescription, Natoms As Long)
'  reads XD .grd file
  Dim A$ ' help variable for reading strings
  Dim i As Integer ' help index for cycles
  Dim RecordLenght As Long
  Dim Lines As Long
  Dim Columns As Long
  Dim Sections As Long
  Dim Min As Single
  Dim Max As Single
  Dim x As Integer
  Dim y As Integer
  Dim z As Integer
  Dim N As Single ' help variable for reading dumy Single
  Dim Dens As Single ' electron density
  Dim GridOrigin(1 To 3) As Single

  Open filename For Input As #1


  'initlaization string
  Line Input #1, A$ '3DGRDFIL  0
  Line Input #1, A$ '         ESP
  Line Input #1, A$ '
  Line Input #1, A$ '! Gridpoints, Origin, Physical Dimensions
  
 'lines coloms section
 Input #1, Lines
 Input #1, Columns
 Input #1, Sections
 VoxelDescription(1) = Lines 'number of x's
 VoxelDescription(2) = Columns 'number of y's
 VoxelDescription(3) = Sections ' number of z's

 ReDim Voxel(VoxelDescription(1), VoxelDescription(2), VoxelDescription(3))
 
 ' DUMMY PROCEDURES FILLING NON USED ELEMENTS
 ' 9 elements of rotation matrix
For i = 1 To 3
    For j = 1 To 3
      PlaneMatrix(i, j) = 0 ' dummy filling
    Next j
Next i

' dummy puting 1 on the diagonal
 PlaneMatrix(1, 1) = 1
 PlaneMatrix(2, 2) = 1
 PlaneMatrix(3, 3) = 1
 
  
  ' 6 lattice parameters
  For i = 1 To 6
    Cell(i) = 1 'dummy filling
  Next i
 
  ' start is aways on 0
  
  For i = 1 To 3 ' for x y z
    VoxelDescription(3 + i) = 0
  Next i
  
  ' END OF DUMMY PROCEDURES
  
 For i = 1 To 3 ' for x y z
    Input #1, N 'Start
    GridOrigin(i) = N
  Next i
      
  For i = 1 To 3
    Input #1, N 'End (used only for step calculation)
    ' 3 elements of translation matrix
    'Calculation of the step
    VoxelDescription(6 + i) = (N - VoxelDescription(3 + i)) / (VoxelDescription(i) - 1)
    PlaneTranslation(i) = (-N / 2) + GridOrigin(i) ' guessed translation setting
   ' Input #1, N 'Division
  Next i
  
 Line Input #1, A$ '! Objects
 
Input #1, Natoms

 ReDim AtomName(1 To Natoms) As String ' name of atoms field
 ReDim AtomDescription(1 To Natoms, 1 To 13) As Single
  ' filed of atoms x,y,z,serial,occ,uiso,u1,u2,u3,u4,u5,u6,AtomNumber
     
  For i = 1 To Natoms
    Line Input #1, A$
    ' FOLOWING LINE OF THE CODE MUST BE REPLACED BY MORE CLEVER ROUTINE
    AtomName(i) = left$(A$, 1) + "   " ' only for experimets !!!!
    ' filling serial,occ,uiso with dummy values
    AtomDescription(i, 4) = 0
    AtomDescription(i, 5) = 0
    AtomDescription(i, 6) = 0
    ' x,y,z
      N = Val(Mid$(A$, 10, 9))
      AtomDescription(i, 1) = N
      N = Val(Mid$(A$, 20, 9))
      AtomDescription(i, 2) = N
      N = Val(Mid$(A$, 30, 9))
      AtomDescription(i, 3) = N
      ' fillin U with 0
    For j = 6 To 12
      AtomDescription(i, j) = 0
    Next j
  Next i
     
Transform AtomDescription, Natoms

Line Input #1, A$ '! Connections
Line Input #1, A$ '0
    

Line Input #1, A$ '! Values

  Min = 1E+30
  Max = -1E+30

  For z = 1 To Sections
  '  Line Input #1, a$ 'BLOCK
  ' Input #1, N 'number of values in one block

    For y = 1 To Columns
        For x = 1 To Lines
        
        Input #1, Dens
        If Dens > 10000 Then
          MsgBox "Your input data looks strange, ELD > 10000"
          Stop
        End If
        If Dens < -10000 Then
          MsgBox "Your input data looks strange, ELD < -10000"
          Stop
        End If
        If Dens > Max Then Max = Dens
        If Dens < Min Then Min = Dens
        Voxel(x, y, z) = Dens
    
        Next x
    Next y
    
  Next z

  VoxelDescription(10) = Min
  VoxelDescription(11) = Max
  
' atoms must be handled in different part of the code
 
Close #1

End Sub
Private Sub Transform(AtomX, Natoms)
  '  frakcnich coordinates -> LSQ plane coordinates system transformation
  Dim i As Integer
  Dim j As Integer
  Dim XcartTrans(1 To 3) As Single
  Dim XNew(1 To 3) As Single

  For i = 1 To Natoms
    
    For j = 1 To 3
      XcartTrans(j) = (AtomX(i, j) - PlaneTranslation(j))
    Next j
    
    MultBy33Matrix XcartTrans, XNew, PlaneMatrix
    
    For j = 1 To 3
      AtomX(i, j) = XNew(j)
    Next j
    
  Next i
  
  ' generating cell coordinates
 
  CellEndPoints(1) = GenerateLatticePoint(0, 0, 0)
  CellEndPoints(2) = GenerateLatticePoint(1, 0, 0)
  CellEndPoints(3) = GenerateLatticePoint(1, 1, 0)
  CellEndPoints(4) = GenerateLatticePoint(0, 1, 0)
  CellEndPoints(5) = GenerateLatticePoint(0, 0, 1)
  CellEndPoints(6) = GenerateLatticePoint(1, 0, 1)
  CellEndPoints(7) = GenerateLatticePoint(1, 1, 1)
  CellEndPoints(8) = GenerateLatticePoint(0, 1, 1)
  
End Sub
Private Function GenerateLatticePoint(t1 As Single, t2 As Single, t3 As Single) As XYZ
Dim XcartTrans(1 To 3) As Single
Dim XNew(1 To 3) As Single

XcartTrans(1) = t1 - PlaneTranslation(1)
XcartTrans(2) = t2 - PlaneTranslation(2)
XcartTrans(3) = t3 - PlaneTranslation(3)

MultBy33Matrix XcartTrans, XNew, PlaneMatrix

GenerateLatticePoint.x = XNew(1)
GenerateLatticePoint.y = XNew(2)
GenerateLatticePoint.z = XNew(3)
  
End Function

Public Sub SavePeaks(NPeaks, Peaks)
  Dim i As Integer
  Dim j As Integer

  Dim Original(1 To 3) As Single
  Dim Transformed(1 To 3) As Single
  Dim InverseMatrix(1 To 3, 1 To 3) As Single
  Dim TransformedPeaks() As Single
  ReDim TransformedPeaks(NPeaks, 3)
  
  InvertMatrix PlaneMatrix, InverseMatrix
 
  For i = 1 To NPeaks
    
    For j = 1 To 3
      Original(j) = Peaks(i, j)
    Next j
   
    Original(1) = Peaks(i, 1)
    Original(2) = Peaks(i, 2)
    Original(3) = Peaks(i, 3)
     
     'transformation back to fractional coordinates
      
    MultBy33Matrix Original, Transformed, InverseMatrix
        
   For j = 1 To 3
       TransformedPeaks(i, j) = Transformed(j) + PlaneTranslation(j)
       'rounding
       TransformedPeaks(i, j) = Int(TransformedPeaks(i, j) * 1000000) / 1000000
    Next j
  Next i
  
  frmMain.CommonDialog1.filename = "newatoms.dat"
  frmMain.CommonDialog1.Filter = "Peak data file (*.dat)|*.dat|All files (*.*)|*.*"
  frmMain.CommonDialog1.ShowSave
  
  Open frmMain.CommonDialog1.filename For Output As #1
  
  For i = 1 To NPeaks
    Print #1, "ATOM Q ";
    Print #1, i; "  ";
    Print #1, "X="; TransformedPeaks(i, 1); " Y="; TransformedPeaks(i, 2); " Z="; TransformedPeaks(i, 3)
  Next i
  
  Close #1

End Sub

Private Sub InvertMatrix(m, mi)
'm Vstupni Matice
'mi vysledek

Dim detM As Single   ' Determinant
Dim D(3, 3)          ' algebraitsky zbytek
Dim DT(3, 3)         'transponovany al. zbytek
Dim i As Single
Dim j As Single

detM = (m(1, 1) * m(2, 2) * m(3, 3) + m(2, 1) * m(3, 2) * m(1, 3) + m(3, 1) * m(1, 2) * m(2, 3)) - (m(3, 1) * m(2, 2) * m(1, 3) + m(1, 1) * m(3, 2) * m(2, 3) + m(2, 1) * m(1, 2) * m(3, 3))

D(1, 1) = (m(2, 2) * m(3, 3) - m(3, 2) * m(2, 3))
D(1, 2) = -(m(2, 1) * m(3, 3) - m(3, 1) * m(2, 3))
D(1, 3) = (m(2, 1) * m(3, 2) - m(3, 1) * m(2, 2))
D(2, 1) = -(m(1, 2) * m(3, 3) - m(3, 2) * m(1, 3))
D(2, 2) = (m(1, 1) * m(3, 3) - m(3, 1) * m(1, 3))
D(2, 3) = -(m(1, 1) * m(3, 2) - m(3, 1) * m(1, 2))
D(3, 1) = (m(1, 2) * m(2, 3) - m(2, 2) * m(1, 3))
D(3, 2) = -(m(1, 1) * m(2, 3) - m(2, 1) * m(1, 3))
D(3, 3) = (m(1, 1) * m(2, 2) - m(2, 1) * m(1, 2))
For i = 1 To 3
    For j = 1 To 3
    DT(i, j) = D(j, i)
    Next j
Next i
For i = 1 To 3
  For j = 1 To 3
    mi(i, j) = 1 / detM * DT(i, j)
  Next j
Next i

End Sub


Private Sub MultBy33Matrix(v1, v2, matrix)
'v1 input vector
'v2 result
'Matrix 3x3 after multiplication
Dim i As Integer
Dim j As Integer

For i = 1 To 3
    v2(i) = 0
    For j = 1 To 3
        v2(i) = v2(i) + matrix(i, j) * v1(j)
    Next j
Next i

End Sub
